﻿const
	script_name='iafd';
	language='English';
	version=15;
	author='Alex/JeF';
	MinProgramBuild=8000;
	Dbg = false;
	PCount = 12;
var
	title, MovieName, year, director, name, character, BasicURL, country, description, salary: string;
	movie_code, movie_site_url, title_code, imdb_code: string;
	titles: array of string;
	titles_count: integer;
	director_code, code: string;
	directors, writers, actors, characters, genres, imdb_codes: array of string;
	directors_codes, writers_codes, actors_codes: array of integer;
	directors_count, writers_count, actors_count, genres_count: integer;
	duration: integer;
	imdb_rating: single;
	front_cover_url: string;
	posters_exists, boxes_exists, screenshots_exists: boolean;
	original_title, mpaa, mpaa_rating: string;
	prefixes: array [1..PCount] of string;
	resolution, barcode, aspect_ratio, features, media_format, video_codec: string;
	
function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank charackters
	while (length(text) > 0) and (ord(text[1]) in [1..32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..32]) do
		delete(text, length(text), 1);
	Result := text;
end;

function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  // Вырезает кусок строки между s1 и s2
	Result := '';
	I := Pos(s1, str);
	if I > 0 then
	begin
		J := MyPos(s2, str, I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

function MovieSearch: integer;
var
	i, j, k: integer;
	s, s2, s3, description, another_title, year, distributor: string;
begin
	s:='';
	titles_count:=0;
	
	//forwarded to the movie page, one result
	if (Pos('- iafd.com - internet adult film database</title>', all)>0) then begin
		i := Pos('http://www.iafd.com/title.rme/title=', all);
		j := MyPos('.htm', all, i+1);
		title_code := copy(all, i+36, j-i-36);
		if title_code<>'' then
			SetSearchResult('title', title_code);
		result := 1;
		exit;
	end;
	
	i:=pos('<p>No Movies found', all);
	if (all='') or (i>0) then
		// Movie not found!
	else begin
		i:=pos('id="titleresult"',all);
		if i>0 then begin
			j:=MyPos('</table>', all, i+1);
			s:=copy(all, i, j-i);
			i:=Pos('<tr', s);
			while i>0 do begin
				s2:=GetStr(s, '<tr', '</tr>');
				if s2 = '' then
					s2 := GetStr(s, '<tr', '<tr');
				if s2 = '' then
					s2 := GetStr(s, '<tr', '</tbody');
				title_code:=ParseString(s2, '<a href="title.rme/title=(.*?).htm">', 1);
				title := GetStr(s2, ' href="title.rme/title', '</a>');
				if title <> '' then
					title:=ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + title)));
				description:=s2;
				//year
				k := Pos('</td><td>', description);
				delete(description, 1, k);
				year := GetStr(description, '<td>', '</td>');
				year := ParseString(year, '(\d+)', 1);
				//distributor
				k := Pos('</td><td>', description);
				delete(description, 1, k);
				distributor := GetStr(description, '<td>', '</td>');
				distributor := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(distributor)));
				//aka
				k := Pos('</td><td>', description);
				delete(description, 1, k);
				another_title:=GetStr(description, '<td>', '</td>');
				another_title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(another_title)));
				if (title<>'') and (title_code <> '') then begin
					titles_count := titles_count + 1;
					SetSearchResult2(title, title_code, year, another_title, distributor, '');
				end;	
				delete(s, 1, i);
				i:=Pos('<tr', s);
			end;
		end;
	end;
	result:=titles_count;
end;

//get  movie name by barcode(UPC-12)
function GetMovieNameByUPC(barcode: string): string;
var
	url, all, s2, s3, res: string;
	i, j: integer;
begin
	res:='';
	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [barcode]);	
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	i:=pos('<Item>', all);
	while (i>0) and (res='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			if s3<>'' then
				res:=s3;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	i:=pos('[', res);
	if i>0 then begin
		j:=MyPos(']', res, i+1);
		if j>0 then
			delete(res, i, j-i+1);
	end;
	result:=res;
end;

//Get search URL by movie name
function GetSearchURLbyName(MovieName, AYear, ABarcode: string): string;
var
	url: string;
begin
	MovieName := ClearExtraBlankCharacters(MovieName);
	MovieName := EncodeURL(MovieName, 'iso-8859-1');
	url:=format('http://www.iafd.com/results.asp?searchtype=title&searchstring=%s', [MovieName]);
	//url:=ReplaceStr(url, ' ', '+', -1);
	result:=url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
begin
	all:=DownloadURL(url);
	if all='-1' then
		result:=-1
	else
		result:=MovieSearch;
end;

function GetMovieURL(code: string; images_only: boolean): string;
begin
	if images_only then
		result:=format('http://www.iafd.com/title.rme/title=%s.htm', [code])
	else
		result:=format('http://www.iafd.com/title.rme/title=%s.htm', [code])
end;


//save front cover to file
function SaveFrontCover(url, FileName: string): boolean;
var
	fs: TFileStream;
	s: string;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
		  fs:=TFileStream.Create(FileName, fmCreate);
  		fs.Write(s, Length(s));
		  fs.Free;
		  result:=true;
	  except
	  	result:=false;
	  end;
	end
	else
		result:=false;
end;


function MovePrefixLeft(name: string): string;
var
	i, j: integer;
begin
	// replace "The", "A", "An"... to the left
	for j:=1 to PCount do
	begin
		i:=pos(', '+Prefixes[j], name);
		if i>0 then
			if (i = length(name)-length(Prefixes[j])-1) or
			(length(name) >= i+2+length(Prefixes[j])) and (name[i+2+length(Prefixes[j])]=':') then
			begin
				if Prefixes[j][length(Prefixes[j])] = '''' then
					name := Prefixes[j] + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1)
				else
					name := Prefixes[j]+' ' + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1);
				break;
			end;
	end;
	Result := name;
end;



function GetInfo(url: string; images_only: boolean): string;
var
	s, s2, s3, keyword, note, genres, genre, small_photo, tmp, credited: string;   //20101007-JeF
	i, j, k: integer;
begin
	result:='';
	BasicURL:=url;
	all:=DownloadURL(url);
	if all='-1' then
		result:='-1'
	else
		result:=all;

	imdb_code:='';

	title:=ParseString(all, '<h1>(.*?) \(\d+\)</h1>', 1);
	title := MovePrefixLeft(title);
	title := DecodeHTML(title);
	if title='' then
		exit;

	movie_code:=ParseString(BasicURL, 'http://www.iafd.com/title.rme/title=(.*?).htm', 1);
	movie_site_url:=GetMovieSiteURL(movie_code);

	//movie year
	year:=ParseString(all, '<h1>.*? \((\d+)\)</h1>', 1);


	//movie duration (minutes)
	duration:=0;
	s := GetStr(all, '<p class="bioheading">Minutes</p>', '</p>');
	s2 := ParseString(s, '(\d+)$', 1);
	if s2<>'' then begin
		try
			duration:=StrToInt(s2);
		except
		end;
	end;
	
	//studio
	s := GetStr(all, '<p class="bioheading">Studio</p>', #10);
	ExtractStudio(s);
	s := GetStr(all, '<p class="bioheading">Distributor</p>', #10);
	ExtractStudio(s);
	s := GetStr(all, '<p class="bioheading">Studio (Distributor)</p>', #10);
	ExtractStudio(s);
	
	//director
	s:=GetStr(all, '<p class="bioheading">Director</p>', '</p>');
	if s = '' then
		s:=GetStr(all, '<p class="bioheading">Directors</p>', '</p>');
	i := Pos('<a href="', s);
	while i>0 do begin
		s2 := GetStr(s, '<a ', '</a>');
		code := GetStr(s2, 'href="/person.rme/perfid=', '.htm');
		code := LowerCase(code);
		if s2 <> '' then
			name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s2)))
		else
			name := '';
		if name <> '' then
			SetPersonName(name, '', 1, code);
		delete(s, 1, i);
		i := Pos('<a href="', s);
	end;
	
	//actors
	s := GetStr(all, '<h3>Performers</h3>', '</div></div></div>');
	i := Pos('<p>', s);
	while i>0 do begin
		s2 := GetStr(s, '<p>', '</div>');
		if s2 = '' then
			s2 := ParseString(s, '<p>(.*?)$', 1);
		code := GetStr(s2, 'href="/person.rme/perfid=', '.htm');
		small_photo := GetStr(s2, 'src="', '"');
		if (Pos('nophoto', small_photo) > 0) then
			small_photo := '';
		name := GetStr(s2, '<a href="/person.rme', '</a>');
		if name <> '' then
			name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + name)));
		character := ClearExtraBlankCharacters(DecodeHTML(GetStr(s2, '</i><br> ', '<br>')));
		if character = '' then
			character := ClearExtraBlankCharacters(DecodeHTML(GetStr(s2, '</a><br> ', '<br>')));
		if character = '' then
			character := ClearExtraBlankCharacters(DecodeHTML(GetStr(s2, ')</i><br>', '<br>')));
		if character = '' then
			character := ClearExtraBlankCharacters(DecodeHTML(GetStr(s2, '</a><br>', '<br>')));
		character := ClearExtraBlankCharacters(character);
		if Pos('<i>', character) > 0 then
			character := '';
		//set characters as genres
		s3 := character;
		repeat
			k := Pos(' ', s3);
			if k > 0 then begin
				tmp := copy(s3, 1, k-1);
				delete(s3, 1, k);
			end
			else
				tmp := s3;
			if tmp <> '' then
				SetGenre(tmp);
		until k = 0;
		credited := GetStr(s2, '<i>(', ')</i>');
		credited := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(credited)));
		if (RegReadInteger('IAFDGetCredited', 0) = 1) and (credited <> '') then begin
			if character <> '' then
				character := character + ', ';
			character := character + credited;
		end;
		if (name <> '') and ((RegReadInteger('IAFDOnlyWomen', 0) = 0) or (Pos('gender=m', code) = 0)) then
			SetPersonName(name, character, 3, code, small_photo);
		delete(s, 1, i);
		i := Pos('<p>', s);
	end;
	
	//aka
	s:=GetStr(all, '<dl><b>Also Known As</b>', '</dl>');
	s := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));
	if s<>'' then
		description:='Also known as: '+s+#13#10;
	
	//scenes
	s:=GetStr(all, '<h3>Scene Breakdowns</h3>', '</ul>');
	description:=description+ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s)));

end;

procedure ExtractStudio(s: String);
var
	i: integer;
	s2: String;
begin
	i := Pos('<a href="', s);
	while i>0 do begin
		s2 := GetStr(s, '<a href="', '</a>');
		if s2 <> '' then
			SetStudio(ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s2))));
		delete(s, 1, i);
		i := Pos('<a href="', s);
	end;
end;

//returned images links
procedure GetImages;
begin

end;



//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='http://www.iafd.com/title.rme/title='+LowerCase(code)+'.htm';
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='http://www.iafd.com/person.rme/perfid='+LowerCase(code)+'.htm';
end;

//show available settings for the script
function ShowScriptOptions: integer;
var
	s: string;
	f: TForm;
	b: TButton;
	cbOnlyWomen, cbGetCredited: TCheckBox;
	my_value: integer;
	
procedure ButtonClick(Sender: TButton);
var
	zn: integer;
begin
	try
		if cbOnlyWomen.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IAFDOnlyWomen', zn);
		if cbGetCredited.Checked then
			zn := 1
		else
			zn := 0;
		RegWriteInteger('IAFDGetCredited', zn);
	except
	end;

	f.ModalResult := mrOk;
end;

begin
	result:=0;
	f := TForm.Create(nil);
	f.Caption := GetLangStr(1924);
	f.BorderStyle := bsDialog;
	f.Position := poScreenCenter;
	f.Width:=400;
	f.Height:=210;
	f.AutoSize:=false;

	
	cbOnlyWomen := TCheckBox.Create(f);
	cbOnlyWomen.Name := 'cbOnlyWomen';
	cbOnlyWomen.Parent := f;
	cbOnlyWomen.SetBounds(10, 10, 350, 20);
	cbOnlyWomen.Caption := 'Add actresses only (no actors)';
	my_value := RegReadInteger('IAFDOnlyWomen', 0);
	if my_value=1 then
		cbOnlyWomen.Checked := True;
		
	cbGetCredited := TCheckBox.Create(f);
	cbGetCredited.Name := 'cbGetCredited';
	cbGetCredited.Parent := f;
	cbGetCredited.SetBounds(10, 30, 350, 20);
	cbGetCredited.Caption := 'Save credited to the character field';
	my_value := RegReadInteger('IAFDGetCredited', 0);
	if my_value=1 then
		cbGetCredited.Checked := True;
		

	b := TButton.Create(f);
	b.Name := 'btnOK';
	b.Parent := f;
	b.SetBounds(160, 150, 80, 25);
	b.Caption := '&OK';
	b.OnClick := @ButtonClick;

	f.ShowModal;
	f.Free;
end;

begin

prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';

end.