const
	script_name='Movieplayer.it';
	language='Italian';
	version=12;
	author='MF';
	MinProgramBuild=8000;
	PCount = 15;
  convertUTF=0;
	//MaxPicturesCount = 3;
var
	DownloadMovieBigCover, DownloadMovieShortCast, DownloadMovieFullCast, 
	DownloadMovieBigDescription, DownloadMovieComments, 
	DownloadMovieStudios,	DownloadMovieAwards, DownloadMovieEarnings, 
	DownloadMovieAdditionalInfo, DownloadMovieSeasonsList: boolean;
	MaxShotsCount, MaxPostersCount, MaxBackdropsCount: integer;
  tmdb_code: String;
	
	searchTitle,title, MovieName, s, s2, s3, s4, year, tagline, director, name, character, BasicURL, country, description, salary, awards: string;
	episodes, movie_code, movie_site_url, title_code, imdb_code: string;
	titles: array of string;
	titles_count: integer;
	atitle, atitle_code, asmall_cover, ayear, aoriginal_title, adescription: array [1..100] of string; 
	i, j: integer;
	director_code, code: string;
	directors, writers, actors, characters, genres, imdb_codes: array of string;
	duration: integer;
	rating, imdb_rating: double;
	TMDBURL, front_cover_url: string;
	posters_exists, ask_amazon: boolean;
	original_title, mpaa, mpaa_rating: string;
	prefixes: array [1..PCount] of string;
	resolution, barcode, aspect_ratio, features, media_format, video_codec: string;

function convUTF(str :string): string;
begin
  result:= str;
  if ( convertUTF=1 ) then result:=ConvertUTF8toASCII(str);
end;

function MovieSearch: integer;
var
	i, j, k, l: integer;
	title, title_code, small_cover, year, original_title, description: string; 
  tipo: string;
begin
	s:='';
  
	i:=Pos('<ul class="search-results-list">', all);
 	if i>0 then begin
		j:=MyPos('</ul>', all, i+1);
 		s:=copy(all, i, j-i);
	end;
	//No results
	if (s='') then
	//otherwise check seach results
	else begin		
 		i:=pos('<li class="search-entry search-result-entry"', s);
		while i>0 do begin
			j:=MyPos('</li>', s, i+1);
			s2:=copy(s, i, j-i);
      //ShowMessage(s2);
			title_code:=ParseString(s2, '.*class="search-entry search-result-entry" data-link="\/film\/([^\/]*)\/">',1);
			if title_code = '' then begin
				title_code:=ParseString(s2, '.*class="search-entry search-result-entry" data-link="\/serietv\/([^\/]*)\/"', 1);
  			if title_code <> '' then begin
          tipo:='[serietv] - ';
          title_code:='serietv/'+title_code;
        end
			end 
			else begin
        tipo:='[film] - ';
				title_code:='film/'+title_code;
			end;
      //ShowMessage(title_code);
      if title_code <> '' then begin
			title:=ParseString(s2, '<h3.*?>.*?<a href=".*?">(.*?)</a>.*?</h3>', 1);
			title:=RemoveTags(title);
			title:=DecodeHTML(title);
			title:=ClearExtraBlankCharacters(title);
			title:=convUTF(title);
			//showMessage(title);
			small_cover := ParseString(s2, '.*<img class="search-entry-poster search-result-poster" src="([^"]*)" ', 1);
			//showMessage(small_cover);
			year := ParseString(s2, '\|</span>.*?([0-9]{4}).*?</span>', 1);
      if year='' then 
  			year := ParseString(s2, '<span class="search-results-result-date">.*?([0-9]{4})</span>', 1);
			original_title := '';
			description := ParseString(s2, '<span class="search-entry-abstract search-result-abstract text-overflow-ellipsis">(.*?)</span>',1);
			description := ClearExtraBlankCharacters(description);
			description := convUTF(description);
			if title<>'' then begin
				titles_count:=titles_count+1;
				atitle[titles_count]:=Trim(title);
				atitle_code[titles_count]:=title_code;
				ayear[titles_count]:=year;
				aoriginal_title[titles_count]:=trim(original_title);
				adescription[titles_count]:=tipo+description;
				asmall_cover[titles_count]:=small_cover;
			end;
      end;
			delete(s, 1, j);
			i:=pos('<li class="search-entry search-result-entry"', s);
		end;
	end;
	//search for nextpage tag
	i:=Pos('>Mostra altro</a>',all);
	result:=i;
end;

//get  movie name by barcode(UPC-12)
function GetMovieNameByUPC(barcode: string): string;
var
	url, all, s2, s3, res: string;
	i, j: integer;
begin
	res:='';
	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [barcode]);	
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	i:=pos('<Item>', all);
	while (i>0) and (res='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			if s3<>'' then
				res:=s3;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	i:=pos('[', res);
	if i>0 then begin
		j:=MyPos(']', res, i+1);
		if j>0 then
			delete(res, i, j-i+1);
	end;
	result:=res;
end;

//Get search URL by movie name
function GetSearchURLbyName(MovieName, AYear, ABarcode: string): string;
var
	url: string;
begin
  //showMessage('MovieName:'+MovieName+' AYear:'+AYear+' ABarcode:'+ABarcode);
	searchTitle:= EncodeURL(MovieName, 'utf-8'); //MovieName;
	url:=format('http://www.movieplayer.it/ricerca/?ct=film.film&q=%s', [searchTitle]);
	url:=ReplaceStr(url, ' ', '+', -1);
	result:=url;

end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
var
  nextpage, cr, j, rc: integer;
  url2,url3: string;
begin
	titles_count:=0;

	j:=Pos('ct=film.film',url);
	url2:=copy(url,1,j-1)+'ct=serietv.serietv&'+copy(url,j+13,length(url)-j-12);
  //ShowMessage(url2);	
	all:=DownloadURL(url2);
	cr:=MovieSearch;
	all:='';
	all:=DownloadURL(url);
  if all = '-1' then
    rc:=-1
  else begin
    nextpage:=1;
    rc:=0;
    cr:=1;
    while cr > 0 do begin
      nextpage:=nextpage+1;
   		cr:=MovieSearch;
   		// if nextpage found and ....
   		if (cr > 0) and (titles_count < 100) then begin
 	      url2:=url+'&pagina='+IntToStr(nextpage);
				//ShowMessage(url2);
	      all:=DownloadURL(url2);
	    end
	    else cr:=0;
 	  end;
  end;
  if titles_count > 0 then begin
    // search match title original_title
    cr:=1;
    searchTitle:=Trim(LowerCase(searchTitle));
    while cr<=titles_count do begin
      if (searchTitle=LowerCase(atitle[cr])) or (searchTitle=LowerCase(aoriginal_title[cr])) then begin
        SetSearchResult2(atitle[cr], atitle_code[cr], ayear[cr], aoriginal_title[cr], adescription[cr], asmall_cover[cr]);
        atitle[cr]:='';
        cr:=titles_count;
      end;
      cr:=cr+1;
  	end;
    // then search like title or original_title
    cr:=1;
    while cr<=titles_count do begin
      if (atitle[cr]<>'') then begin
        if (Pos(searchTitle,LowerCase(atitle[cr]))>0) or (Pos(LowerCase(atitle[cr]),searchTitle)>0) then begin
          SetSearchResult2(atitle[cr], atitle_code[cr], ayear[cr], aoriginal_title[cr], adescription[cr], asmall_cover[cr]);
          atitle[cr]:='';
        end
        else begin
          if (Pos(searchTitle,LowerCase(aoriginal_title[cr]))>0) or (Pos(LowerCase(aoriginal_title[cr]),searchTitle)>0) then begin
            SetSearchResult2(atitle[cr], atitle_code[cr], ayear[cr], aoriginal_title[cr], adescription[cr], asmall_cover[cr]);
            atitle[cr]:='';
          end;
        end;
      end;
      cr:=cr+1;
  	end;
    // then add the others...
    cr:=1;
    while cr<=titles_count do begin
      if (atitle[cr]<>'') then begin
        SetSearchResult2(atitle[cr], atitle_code[cr], ayear[cr], aoriginal_title[cr], adescription[cr], asmall_cover[cr]);
      end;
      cr:=cr+1;
  	end;
	end 
  else begin
    titles_count:=-1;
  end;    
  result:=titles_count;
end;

function GetMovieURL(code: string; images_only: boolean): string;
begin
		result := 'http://www.movieplayer.it/' + code + '/';
end;



//save front cover to file
function SaveFrontCover(url, FileName: string): boolean;
var
	fs: TFileStream;
	s: string;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;
function MySavePage(s , FileName: string): boolean;
var
	fs: TFileStream;
begin
	if length(s)>0 then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function GetStr(str: String; s1: String; s2: String): String;
var
	I: Integer;
	J: Integer;
begin
	// -=  =  s1  s2
	Result := '';
	I := Pos(LowerCase(s1), LowerCase(str));
	if I > 0 then
	begin
		J := MyPos(LowerCase(s2), LowerCase(str), I + Length(s1));
		if J > 0 then
			Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;


function GetInfo(url: string; images_only: boolean): string;
var 
	studio1, refer, keyword, s, s2, s3, s4, urla, urli, alli, name, code, character, mode,episodi,anni,urlImage: string;
	i, j, k, l, t, imode, frames_count, pmode: integer;
	FilmmakersSection: Boolean;
	isFilm: integer;
begin
	result:='';
	refer:=format('http://www.movieplayer.it/adv/interstitial/2.html?next=/%s/',[movie_code]);
	all:=DownloadURLWithReferer(url,refer);
	//showMessage(url);
	
	//showMessage('GetInfo:'+url);
	if all='-1' then
		result:='-1'
	else
		result:=all;
    
	isFilm:=1;
	movie_code := ParseString(url, '\/(film\/.*?)\/$', 1);
	if movie_code = '' then begin
		isFilm:=0;
		movie_code := ParseString(url, '\/(serietv\/.*?)\/$', 1);
	end;
	//showMessage(movie_code);
 	
	movie_site_url:=GetMovieSiteURL(movie_code);
	//showMessage(movie_site_url);

	//year
	year:=ParseString(all, '<time itemprop="datePublished" datetime=".*?">.*?(\d{4})</time>', 1);
  if year = '' then
    year:=ParseString(all,'<title>.*?film (\d{4}) - Movieplayer.it</title>',1);
  if year  = '' then
    year:=ParseString(all,'<title>.*?Serie TV (\d{4}) - Movieplayer.it</title>',1);
  //showMessage(year);

	//movie title
	title:=ParseString(all, '<div class="film-header-info">.*?<h1 itemprop="name">(.*)</h1>', 1);
	title:=DecodeHTML(title);
	title:=ClearExtraSpaces(title);
	title:=convUTF(title);
  //showMessage(title);

	if title='' then
		exit;
		
	//original title
	s:=GetStr(all, '<span class="film-extra-info-label">Titolo originale:</span>', '</li>');
  //ShowMessage(s);
	original_title:=ParseString(s, '.*>(.*?)</span>', 1);
	if (original_title='') then
		original_title:=title		
	else
    original_title:=convUTF(original_title);
	//showMessage('OT:'+original_title);
		
	//Distributore
	s:=GetStr(all, '<span class="film-extra-info-label">Distributore:</span>', '</li>');
  //ShowMessage(s);
	studio1:=ParseString(s, '.*>(.*?)</span>', 1);
	//showMessage('Studio:'+studio1);

  //Rating x/10
  s2:=ParseString(all,'<span class="film-star-label left">(\d)<span',1);
  s3:=ParseString(all,'<span class="film-star-label-half">(\d)</span></span>',1);
	s:=S2+DecimalSeparator+s3;
  try
		rating:=StrToFloat(s)*2;
	except
		end;
	
	//Tagline
	tagline:='';
	i:=Pos('<h2>Curiosit e citazioni</h2>',all);
	if i>0 then begin
		j:=MyPos('</section>',all,i);
		s:=copy(all,i,j-i);
		s:=RemoveEndLines(s);
		//showMessage(s);
		s3:=ParseString(s, '<p class="expandable-text">[^<]*?<i>(.*)</i>',1);
		if s3 <> '' then begin
			tagline:=RemoveTags(s3);
			tagline:=DecodeHTML(tagline);
		  tagline:=convUTF(tagline);
			tagline:=ClearExtraSpaces(tagline);
		  //showMessage('tag'+tagline);
		end;
	end;

	//genre
  s:=ParseString(all, '<span class="film-info-label">Genere</span>.*?</div>.*?<div class="film-info-col">\s*?([A-Z].*?)</div>',1);
	s:=RemoveTags(s);
	s:=ClearExtraSpaces(s);
  //showMessage(s);
	i:=Pos(',', s);
	while i>0 do begin
		s3:=copy(s, 1, i-1);
  	s3:=ClearExtraSpaces(s3);
    //showMessage('Genre:'+s3);
		if s3<>'' then begin
			s3:=UpperCase(copy(s3,1,1))+LowerCase(copy(s3,2,length(s3)-1));  
			SetGenre(s3);
		end;
		delete(s, 1, i);
		i:=Pos(',', s);
	end;
	if s<>'' then begin
  	s:=ClearExtraSpaces(s);
		s:=UpperCase(copy(s,1,1))+LowerCase(copy(s,2,length(s)-1));  
    //showMessage('Genre2:'+s);
		SetGenre(s);
	end;

	
	//country
	if isFilm=1 Then Begin
  	s:=GetStr(all, '<span class="film-extra-info-label">Nazione:</span>', '</li>');
  	s:=ParseString(s, '.*>(.*?)</span>', 1);
  	s:=ClearExtraSpaces(s);
   	i:=Pos(',', s);
  	while i>0 do begin
  		s3:=copy(s, 1, i-1);
      //showMessage('Country:'+s3);
   		if s3<>'' then
  			SetCountry(s3);
  
  		delete(s, 1, i+1);
  		i:=Pos(',', s);
  	end;
    //showMessage('Country:'+s);
   	if s<>'' then
  		SetCountry(s);
  end;
	
	//duration
	s:=ParseString(all, '<div class="film-info-col">.*?<span class="film-info-label">Durata</span>.*?</div>.*?<div class="film-info-col">.*?(\d*) minuti.*?</div>',1);
	//showMessage('Durata:'+s);
	try
		duration:=StrToInt(s);
	except
    end;
	
	//description
	if isFilm=1 Then Begin		
		description:=ParseString(all, '<p itemprop="description" class="expandable-text">(.*?)</p>', 1);
		if description = '' then
			description := GetStr(all, '<p itemprop="description">', '</p>');
	end
	else begin
		description:=ParseString(all, '<hr class="full-width">.*?<p class="expandable-text">(.*?)</p>', 1);
	end;
	description:=RemoveTags(description);
	description:=DecodeHTML(description);
	description:=ClearExtraBlankCharacters(description);
	description:=convUTF(description);

	///////////////////// 
	//download cast page
	urla:=format('/%s/cast/',[movie_code]);
	urla:=ReplaceStr(urla, ' ', '+', -1);
  refer:=format('http://www.movieplayer.it/adv/interstitial/2.html?next=/%s/cast/',[movie_code]);
	all:=DownloadURLWithReferer(urla,refer);
  //all:=RemoveEndLines(all);
  
  //ShowMessage(all);
	
  i:=Pos('<h3>Case di Produzione</h3>',all);
  if (i>0) then begin
  	j:=MyPos('</ul>',all,i);
  	s:=copy(all,i,j-i);
		i:=Pos('<li>',s);
  	while (i>0) do begin 
		 	s:=copy(s,i,length(s)-i);
  		j:=Pos('</li>',s);
		 	s3:=copy(s,1,j+5);
			studio1:=ParseString(s3,'<li>(.*?)</li>',1);
			i:=MyPos('<li>',s,2);
			studio1:=convUTF(studio1);
			studio1:=DecodeHTML(studio1);
			//showMessage('S='+s3+' Studio:'+Studio1);
			SetStudio(studio1);
		end;
	end
	else begin
		//from scheda page
		if ( studio1 <> '' ) then
			SetStudio(studio1);
	end; 
  
  ///////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////
  //Attori
  ////////
	if isFilm = 1 Then Begin
    s:=GetStr(all,'<ul class="cast-list film-cast-all-members">','</ul>');
  end
  else Begin
    s:=GetStr(all,'<ul class="cast-list serie">','</ul>');
  end;
  //ShowMessage(s);
  if (s<>'') then begin
 			i:=Pos('<li>',s);
    	while (i>0) do begin
    		delete(s, 1, i+1);
 				j:=Pos('</li>',s);
    		s3:=copy(s,1,j);
    		s3:=RemoveEndLines(s3);
    		//showMessage(s3);
        code:=ParseString(s3, 'href="/personaggi/([^/]*?)/"', 1);
        urlImage:=ParseString(s3,'data-prograsync-background-image-1="url\((.*?)\)', 1);
        //showMessage('image:'+urlImage);
				if isFilm = 1 Then Begin
          s4:=ParseString(s3,'<span class="cast-list-name">.*?<a href=.*?>(.*?)</a>',1);
  		    s3:=ParseString(s3, '<span class="cast-list-role.*?>(.*?)</span>', 1);
        end
        else begin
          s4:=ParseString(s3,'<span class="cast-list-name.*?> *(.*?) *</span>',1);
          
     		  character:=ParseString(s3, '<span class="cast-list-role.*?"> *(.*?) *?</span>', 1);
    		  //showMessage(character);
					episodi:=ParseString(s3,'<span class="cast-list-serie-episodes"> *?(\d*) episodi.*?</span>', 1);
					anni:=ParseString(s3, '<span class="cast-list-serie-years">(\(.*?\))</span>', 1);
					if (episodi<>'') and (anni <>'') then begin
						 s3:=character+' ('+episodi+' episodi '+anni+')';
					end 
					else begin
					   if episodi<>'' then begin
							 s3:=character+' ('+episodi+' episodi)';
             end
             else begin
              s3:=character;
             end 
          end	
	  		end;
		    character:=convUTF(s3);
			  character:=DecodeHTML(character);
  			//ShowMessage('Name:'+s4+'   Role:'+character+'       Code:'+code);
        if urlImage = '' then begin
           SetPersonName(s4,character,3,code);
        end
        else begin
           j:=Pos('/images/',urlImage);
           i:=Pos('_jpg_60x60_crop_q85.jpg',urlImage);
           s3:=copy(urlImage,j,i-j);
           //showMessage(s3);
           SetPersonName(s4,character,3,code,'http://images.movieplayer.it'+s3+'.jpg');
        end;
				i:=Pos('<li>',s);
			end;	  
  end;

 	if isFilm <> 1 Then Begin
    ////////////////////////////////////
    //SERIE TV Regia/Scrittori/Musiche
    ////////////////////////////////////
    t:=0;
    while t<4 do begin
      s:='';
      case t of
        0: begin       
          i:=Pos('    Regia',all);
          j:=MyPos('</ul>',all,i);
          s:=copy(all,i,j-i);
          pmode:=1;
          end;  
        1: begin
          i:=Pos('    Sceneggiatura',all);
          j:=MyPos('</ul>',all,i);
          s:=copy(all,i,j-i);
          pmode:=2;
          end;
        2: begin
          i:=Pos('    Creata da',all);
          j:=MyPos('</ul>',all,i);
          s:=copy(all,i,j-i);
          pmode:=2;
          end;
        3: begin
          i:=Pos('<h3>Musiche</h3>',all);
          j:=MyPos('</ul>',all,i);
          s:=copy(all,i,j-i);
          pmode:=4;
          end;
      end;
      t:=t+1;
      //ShowMessage(s);
      if (s<>'') then begin
     			i:=Pos('<li>',s);
        	while (i>0) do begin
        		delete(s, 1, i+1);
     				j:=Pos('</li>',s);
        		s3:=copy(s,1,j);
        		s3:=RemoveEndLines(s3);
        		//showMessage(s3);
            code:=ParseString(s3, 'href="/personaggi/([^/]*?)/"', 1);
            urlImage:=ParseString(s3,'data-prograsync-background-image-1="url\((.*?)\)', 1);
            //showMessage('image:'+urlImage);
            s4:=ParseString(s3,'<span class="cast-list-name.*?> *(.*?) *</span>',1);
            if s4 = '' then
              s4:=ParseString(s3,'<a href="/personaggi.*?">(.*?)</a>',1);
              
            //ShowMessage(s4);  
            if urlImage = '' then begin
               SetPersonName(s4,'',pmode,code);
            end
            else begin
               j:=Pos('/images/',urlImage);
               i:=Pos('_jpg_60x60_crop_q85.jpg',urlImage);
               s3:=copy(urlImage,j,i-j);
               //showMessage(s3);
               SetPersonName(s4,'',pmode,code,'http://images.movieplayer.it'+s3+'.jpg');
            end;
    				i:=Pos('<li>',s);
    			end;	  
      end;
    end
  end
  else begin
    ////////////////////////////////////
    //FILM Regia/Scrittori
    ////////////////////////////////////
    s:=GetStr(all,'<h2>Autori</h2>','</ul>');
    //ShowMessage(s);
    
    if (s<>'') then begin
 			i:=Pos('<li',s);
    	while (i>0) do begin
    		delete(s, 1, i+1);
 				j:=Pos('</li>',s);
    		s3:=copy(s,1,j);
    		s3:=RemoveEndLines(s3);
        code:=ParseString(s3, 'href="/personaggi/([^/]*?)/"', 1);
        urlImage:=ParseString(s3,'data-prograsync-background-image-1="url\((.*?)\)', 1);
        //showMessage('image:'+urlImage);
        s4:=ParseString(s3,'<span class="cast-list-name">.*?<a href.*?>(.*?)</a>',1);
		    character:=ParseString(s3, '<span class="cast-list-role">(.*?)</span>', 1);
		    character:=convUTF(character);
			  character:=DecodeHTML(character);
        case character of
        'Regia': begin
          pmode:=1;
          end;
        'Sceneggiatura': begin
          pmode:=2;
          end;
        'Soggeto': begin
          pmode:=3;
          end;
        end;
    		//showMessage('Name:'+s4+'    Role:'+character);
        if urlImage = '' then begin
           SetPersonName(s4,'',pmode,code);
        end
        else begin
           j:=Pos('/images/',urlImage);
           i:=Pos('_jpg_60x60_crop_q85.jpg',urlImage);
           s3:=copy(urlImage,j,i-j);
           //showMessage(s3);
           SetPersonName(s4,'',pmode,code,'http://images.movieplayer.it'+s3+'.jpg');
        end;
				i:=Pos('<li',s);
			end;	  
    end;
    ////////////////////////////////////
    //FILM Musiche
    ////////////////////////////////////
    s:=GetStr(all,'<h3>Musiche</h3>','</ul>');
    //ShowMessage(s);
    
    if (s<>'') then begin
 			i:=Pos('<li>',s);
    	while (i>0) do begin
    		delete(s, 1, i+1);
 				j:=Pos('</li>',s);
    		s3:=copy(s,1,j);
    		s3:=RemoveEndLines(s3);
    		//showMessage(s3);
        code:=ParseString(s3, 'href="/personaggi/([^/]*?)/"', 1);
        s4:=ParseString(s3,'<a href="/personaggi/.*?">(.*?)</a>',1);
        SetPersonName(s4,'',4,code);
				i:=Pos('<li>',s);
			end;	  
    end;
  end;
  

  ////////////////////////////////////
	// Image poster,film shoot,wallpaper 
  t:=0;
  while t<3 do begin
    case t of
      0: begin
      	urli:=format('/%s/galleria/?tipologia=manifesti-e-poster',[movie_code]);
      	urli:=ReplaceStr(urli, ' ', '+', -1);
        refer:=format('http://www.movieplayer.it/adv/interstitial/2.html?next=/%s/galleria/?tipologia=manifesti-e-poster',[movie_code]);
      	alli:=DownloadURLWithReferer(urli,refer);
        imode:=1;
        s:=GetStr(alli,'<div class="film-poster">','</div>');
        if s <> '' then begin
          s2:=ParseString(s,'<img src-1="\(max-width:.*?\) (.*?)"',1);
          //ShowMessage(s2);
          if s2 <> '' then begin
            j:=Pos('/images/',s2);
            i:=Pos('_jpg_',s2);
            s3:=copy(s2,j,i-j);
            //showMessage(s3);
            SetImageName('','http://images.movieplayer.it'+s3+'.jpg', '', imode);
          end;
        end;
		GetImgs(alli, 4, MaxPostersCount);
      end;  
      1: begin
      	urli:=format('/%s/galleria/?tipologia=wallpaper',[movie_code]);
      	urli:=ReplaceStr(urli, ' ', '+', -1);
        refer:=format('http://www.movieplayer.it/adv/interstitial/2.html?next=/%s/galleria/?tipologia=wallpaper',[movie_code]);
      	alli:=DownloadURLWithReferer(urli,refer);
        imode:=7;
		GetImgs(alli, imode, MaxBackdropsCount);
      end;
      2: begin
      	urli:=format('/%s/galleria/?tipologia=foto-di-scena',[movie_code]);
      	urli:=ReplaceStr(urli, ' ', '+', -1);
        refer:=format('http://www.movieplayer.it/adv/interstitial/2.html?next=/%s/galleria/?tipologia=foto-di-scena',[movie_code]);
      	alli:=DownloadURLWithReferer(urli,refer);
        imode:=3;
		GetImgs(alli, imode, MaxShotsCount);
      end;
    end;
    t:=t+1;
  end;
  ////////////////////////////////////
	// TMDB data 
//	if isFilm=1 Then Begin
//    GetTMDBData;
//  end;
  // http://www.thetvdb.com/api/D6869395A86DEFB8/series/73739/all/it.xml

end;

procedure GetImgs(text: string; imode, imax: integer);
var
	s, s2, s3: String;
	i, j, k: integer;
begin
	s:=GetStr(text,'<ul id="image-gallery" class="image-gallery-container">','</ul>');
    //showMessage(s);
    i:=Pos('<li',s); 
   	k:=0;
  	while (i>0) and (k < imax) do begin
      delete(s,1,i);
      j:=Pos('</li>',s);
      s3:=copy(s,1,j);
      s2:=GetStr(s3, 'src="', '"');
      j:=Pos('/images/',s2);
      i:=Pos('_jpg_',s2);
      s3:=copy(s2,j,i-j);
	  if s3 <> '' then begin
		SetImageName('','http://images.movieplayer.it'+s3+'.jpg', '', imode);
		k:=k+1;
	  end;
      i:=Pos('<li',s);
    end;
end;
//download other data from themoviesdb.org
function GetTMDBData: integer;
var
	url, all, s, tt,tot,ty: string;
	y, i, j, k, kol: integer;
begin
	result:=0;
 
 	//search movie	
	url:=format('http://api.themoviedb.org/2.1/Movie.search/it/xml/df26c33ba1e6b4940727aa15d777ab97/%s', [title]);
	url:=ReplaceStr(url, ' ', '%20', -1);
	url:=ReplaceStr(url, '''', '%20', -1);
	//showMessage(url);

	all:=DownloadURL(url);
  //showMessage(all);
	if ( all='-1' ) or (pos('<opensearch:totalResults>0<', all)>0) then begin
		url:=format('http://api.themoviedb.org/2.1/Movie.search/it/xml/df26c33ba1e6b4940727aa15d777ab97/%s', [original_title]);
		url:=ReplaceStr(url, ' ', '%20', -1);
  	url:=ReplaceStr(url, '''', '%20', -1);
		//showMessage(url);
		all:=DownloadURL(url);
    //showMessage(all);
  	if ( all='-1' ) or (pos('<opensearch:totalResults>0<', all)>0) then begin
  		exit;
  	end;
	end;
	
  i:=pos('<movie>',all);
  while (i>0) do begin
    delete(all, 1, i+7);
    j:=pos('</movie>',all);
    s:=copy(all,1,j);
    tt:=ParseString(s, '<name>(.*?)</name>', 1);
    tot:=ParseString(s, '<original_name>(.*?)</original_name>', 1);
    ty:=ParseString(s, '<released>(....)-..-..</released>', 1);
    y:=StrToInt(ty)-StrToInt(year);
    //showMessage('['+tt+'] - ['+title+'] --- ['+tot+'] - ['+original_title+']');
    if (((LowerCase(tt)=LowerCase(title)) or (LowerCase(tot)=LowerCase(original_title)) or (LowerCase(tt)=LowerCase(original_title))) and (abs(y)<2)) then begin
       i:=-999;
    end
    else begin
      i:=pos('<movie>',all);
    end;
  end;
  if (i<>-999) then exit;
  
  tmdb_code:=ParseString(s, '<id>(.*)</id>', 1);
  imdb_code:=ParseString(s, '<imdb_id>(.*)</imdb_id>', 1);

  //Get data from imdb.com
 	url:=format('http://www.imdb.com/title/%s/', [imdb_code]);
	url:=ReplaceStr(url, ' ', '%20', -1);
 	all:=DownloadURL(url);
  mpaa_rating:=ParseString(all, '<span itemprop="contentRating">(.*?)</span>', 1);
  mpaa:=ParseString(mpaa_rating,'Rated (.*?) ',1); 
  s:=ParseString(all, '<span itemprop="ratingValue">(.*?)</span>', 1);
  i:=pos('.', s);
	if i>0 then
		s[i]:=DecimalSeparator;
		try
			imdb_rating:=StrToFloat(s);
		except
	end;

  //Get Data from tmdb
 	url:=format('http://api.themoviedb.org/2.1/Movie.getInfo/it/xml/df26c33ba1e6b4940727aa15d777ab97/%s', [tmdb_code]);
	url:=ReplaceStr(url, ' ', '%20', -1);
	all:=DownloadURL(url);
  i:=pos('<image type="backdrop"',all)-2;
  //<image type="backdrop" url="http://cf2.imgobject.com/t/p/w1280/tg7UGXaUROpzY5ppPh7dnvy4l7P.jpg" size="w1280" width="1280" height="720" id="4ea61733a34d4b41fd000e13"/>  
  k:=0;
  while (i>0) and (k<4) do begin
    delete(all,1,i);
    i:=pos('"w1280"',all);
    if (i>0) then begin
     s:=copy(all,1,i+10);
     url:=ParseString(s,'<image type="backdrop" url="([^"]*)" size="w1280"',1);
     //ShowMessage(url);
     k:=k+1;
  	 SetImageName('', url, '', 3);
    end;
  end;       
end;

//returned images links
procedure GetImages;
begin
		if front_cover_url<>'' then
			SetImageName('', front_cover_url, '', 1);
end;

function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank charackters
	while (length(text) > 0) and (ord(text[1]) in [1..20, 32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..20, 32]) do
		delete(text, length(text), 1);
	Result := text;
end;

//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else	
		result := 'http://www.movieplayer.it/' + code + '/';
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='http://www.movieplayer.it/personaggi/' + code + '/';
end;


begin

prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';
prefixes[13]:='I';
prefixes[14]:='Gli';
prefixes[15]:='Lo';
end.