const
	script_name='Movieplayer.it';
	language='Italian';
	version=7;
	author='MF';
	MinProgramBuild=8000;
	PCount = 12;
  convertUTF=0;
	//MAX_PHOTOS_COUNT = 3;
var
	DownloadPersonBiography, DownloadPersonAdditionalInfo: boolean;
	MaxPhotosCount: integer;
	
	persons_count: integer;
	persons: array of string;
	imdb_codes: array of string;
	imdb_code, person_code: string;
	searchName,search_url,name, code, year, description: string;
	person, BasicURL, biography, trivia, character, birth_date, birthplace, birth_name, salary, height, original_name, death_date, person_site_url: string;
	photo_url: string;
	monthes: array [1..12] of string;
	prefixes: array [1..PCount] of string;
	movie_html: string;
	person_height: integer;
	photo_all: string;

function GetStr(str: String; s1: String; s2: String): String;
var
	I: Integer;
	J: Integer;
begin
	// -ݭii= ݵ = i s1  s2
	Result := '';
	I := Pos(LowerCase(s1), LowerCase(str));
	if I > 0 then
	begin
		J := MyPos(LowerCase(s2), LowerCase(str), I + Length(s1));
		if J > 0 then
			Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;

function convUTF(str :string): string;
begin
  result:= str;
  if ( convertUTF=1 ) then result:=ConvertUTF8toASCII(str);
end;

function GetSearchURLbyName(PersonName: string): string;
var
	url: string;
begin
  searchName:= EncodeURL(PersonName, 'utf-8');
	url:=format('http://www.movieplayer.it/ricerca/?ct=people.people&q=%s', [SearchName]);
	url:=ReplaceStr(url, ' ', '+', -1);
	search_url:=url;
	result:=url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
var s: string;
begin
//showMessage(url);
	all:=DownloadURL(url);
	if all='-1' then begin
    //showMessage('-1');
		result:=-1;
	end
  else begin
  	//s:=copy(all,1,100);
    //showMessage(s);
		result:=PersonSearch;
  end;
end;

function PersonSearch: integer;
var
	url, s, s2, s3,Description,small_cover: string;
	i, j, k, next_page: integer;
begin
	persons_count:=0;
	next_page:=1;
  
  //showMessage(all);
	while next_page>0 do begin
  	i:=Pos('<ul class="search-results-list">', all);
 	  if i>0 then begin
  		j:=MyPos('</ul>', all, i+1);
   		s:=copy(all, i, j-i);
  		i:=Pos('<li class=', s);
  		while i>0 do begin
          j:=MyPos('</li>', s, i+1);
  				s2:=copy(s, i, j-i);
          //showMessage('S2:'+s2);
  				original_name:='';
  				person_code:=ParseString(s2,'<h3.*?<a href="/personaggi/(.*?)">.*?</a>.*?</h3>',1);
  				name:=ParseString(s2,'<h3.*?<a href="/personaggi/.*?">(.*?)</a>.*?</h3>',1);
   				//showMessage(person_code+'----'+name);
  				if name <> ''  then  begin
            name := convUTF(name);
    				small_cover:=ParseString(s2,'<img class="search-entry-poster search-result-poster" src="(.*?)"',1);
            s3:=copy(small_cover,1,5);
            if s3 <> 'http:' then small_cover:='http://movieplayer.it/'+small_cover; 
            
    				Description:=ParseString(s2, '\|</span>(.*?)</span>', 1);
            Description:=RemoveTags(Description);
            Description:=DecodeHTML(Description);
            Description:=ClearExtraBlankCharacters(Description);
  
            if (Description <> '') then
              Description:='Nato/a il: '+Description;
            
            if (persons_count<50) then begin  
  				    persons_count:=persons_count+1;
    				  SetLength(persons, persons_count);
    				  SetSearchResult2(name, person_code, '', original_name, Description, small_cover);
            end else begin
              next_page:=-1;
            end;
  				end;
    			delete(s, 1, j);
    			i:=pos('<li class=', s);
  		end;
		end;
		if (next_page > 0) and (Pos('>Mostra altro</a>',all) > 0) then begin
			if next_page < 2 then begin
				next_page:=next_page+1;
			  url:=search_url+format('&pagina=%d',[next_page]);
			  //showMessage(url);
				all:=DownloadURL(url);
				if all='-1' then
				   next_page:=-1;
			end else begin
				next_page:=-1;
			end;
		end else begin
				next_page:=-1;
		end;
	end;
//  ShowMessage(persons_count);
	result:=persons_count;
end;

function GetPersonURL(code: string; images_only: boolean): string;
begin
		result:=format('http://www.movieplayer.it/personaggi/%s/', [code]);
end;


//returnes images links
procedure GetImages;
var
	i, j, photo_cnt: Integer;
	s,s2: String;
begin
	if photo_url<>'' then
		SetImageName('', photo_url, '', 6);

	if (MaxPhotosCount>1) and (photo_all<>'-1') then begin
		photo_cnt := 1;
		i := Pos('<ul class="news_list users_list">',photo_all);
		photo_all:=copy(photo_all,1,i);
		i := Pos('<div class="images_box">',photo_all);
		while (i>0) and (photo_cnt < MaxPhotosCount) do begin
			delete(photo_all, 1, i);
			i:=Pos('</a>',photo_all);
			s2:=copy(photo_all,1,i);
			s:=ParseString(s2,'<img src="(.*?)_thumb.jpg"',1);
			if s='' then
			  i:=-1
			else begin
				s:=s+'.jpg';
				//showMessage('PHOTO:['+s+']');
				SetImageName('', s , '', 6);
				photo_cnt := photo_cnt + 1;
			end;
		end;
	end;
	//GetGoogleImage;
end;

function GetGoogleImage: boolean;
var
	all, url: string;
	i, j: integer;
begin
	url:=format('http://images.google.com/images?svnum=20&hl=en&lr=&safe=on&c2coff=1&q=%%22%s%%22', [person]);
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	i:=pos('dyn.Img(', all);
	if i>0 then begin
		i:=MyPos('","', all, i+1);
		i:=MyPos('","', all, i+1);
		i:=MyPos('","', all, i+1) + 3;
		j:=MyPos('","', all, i+1);
		if j>0 then begin
			url:=copy(all, i, j-i);
			SetImageName('', url, '', 6);
		end;
	end;
end;

function SavePhoto(url, FileName: string): boolean;
var
	fs: TFileStream;
	s: string;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function ClearBrackets(name: string): string;
var
	i: integer;
begin
	// clear word in brackets at the end of name
	i := pos(' (', name);
	if i>0 then
		name := copy(name, 1, i-1);
	Result := name;
end;

function ClearExtraQuotes(name: string): string;
begin
	// Clears extra quotes "+
	if length(name)>0 then
		if (name[1]='"') and (name[length(name)]='"') then
			name := copy(name,2,length(name)-2);
	Result := name;
end;

function MyRemoveTags(s: string): string;
var
	i, j: integer;
begin
	i:=pos('<', s);
	while i>0 do begin
		if i=MyPos('<br />', s, i) then begin
			delete(s, i+6, 1);
			i:=MyPos('<', s, i+1);
		end
		else begin
			j:=MyPos('>', s, i+1);
			delete(s, i, j-i+1);
			i:=MyPos('<', s, i);
		end;
	end;
	result:=s;

end;
function getMonthNum(month: string): string;
begin
  case month of
  'gennaio': begin
     result:='01';
  end;
  'febbraio': begin
     result:='02';
  end;
  'marzo': begin
     result:='03';
  end;
  'aprile': begin
     result:='04';
  end;
  'maggio': begin
     result:='05';
  end;
  'giugno': begin
     result:='06';
  end;
  'luglio': begin
     result:='07';
  end;
  'agosto': begin
     result:='08';
  end;
  'settembre': begin
     result:='09';
  end;
  'ottobre': begin
     result:='10';
  end;
  'novembre': begin
     result:='11';
  end;
  'dicembre': begin
     result:='12';
  end;
  end;
end;
function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank charackters
	while (length(text) > 0) and (ord(text[1]) in [1..32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..32]) do
		delete(text, length(text), 1);
	Result := text;
end;


function GetInfo(url: string; images_only: boolean): string;
var
	filmUrl,bioUrl, s, s2, s3, s4, all2  , day, refer,refer2, month, year, next_page, mov_title, mov_code,anni,episodi: string;
	isSerie,isPhoto,isMovie,isBio,i, j, k, l, mode, page: integer;
begin
	result:='';
	BasicURL:=url;
	person_code:=ParseString(url,'http://www.movieplayer.it/personaggi/([^/]*?)/', 1);
	refer:=format('http://www.movieplayer.it/adv/interstitial/2.html?next=/personaggi/%s/',[person_code]);
  refer2:=refer;
	all:=DownloadURLWithReferer(url,refer);

	bioUrl:=url+'biografia/';
	filmUrl:=url+'filmografia/';
	person_site_url:=url;

	if all='-1' then
		result:='-1'
	else
		result:=all;

	//name
	person := ParseString(all, '<meta name="title" content="(.*?)" />', 1);
	person := DecodeHTML(person);
	person := convUTF(person);
	//showMessage(person+" - "+person_code);
	
	//original name
	original_name:= ParseString(all, '<meta name="nome_completo" content="(.*?)" />', 1);
	original_name:= DecodeHTML(original_name);
	original_name := convUTF(original_name);
	//showMessage(original_name);
	
	//Date of birth
  s:=GetStr(all,'class="timeline-cake">','/div>');
 	birth_date:='';
	if s <> '' then begin
    i:=Pos('</svg>',s);
    delete(s,1,i+5);
    s2:=ParseString(s,' *\d+ anni, (.*?)<',1);
		day:=ParseString(s2, '^(\d+) ', 1);
		month:=ParseString(s2, '^\d+ ([a-z]+) ', 1);
		year:=ParseString(s2, '^\d+ [a-z]+ (\d{4})', 1);
  	birth_date:=getMonthNum(month)+'/'+day+'/'+year;
  end;
  //showMessage(birth_date);

  //Place of birth
  s:=GetStr(all,'class="timeline-marker">','/div>');
	birthplace:='';
	if (s<>'') then begin
    i:=Pos('</svg>',s);
    delete(s,1,i+5);
   //ShowMessage(s); 
	  birthplace:=ParseString(s,' *(.*?)<',1);
	  birthplace := convUTF(birthplace);
  end;
  //showMessage(birthplace);
  
	//Date of death
  s:=GetStr(all,'<li class="timeline-divider-container">','</li>');
  if s <> '' then begin
    s:=RemoveEndLines(s);
    s2:=ParseString(s,'Mort[oa] - (\d+ [a-z]+ \d{4}) *</div>',1);
    //ShowMessage(s+'   S2:'+s2);
		day:=ParseString(s2, '^(\d+) ', 1);
		month:=ParseString(s2, '^\d+ ([a-z]+) ', 1);
		year:=ParseString(s2, '^\d+ [a-z]+ (\d{4})', 1);
  	death_date:=getMonthNum(month)+'/'+day+'/'+year;
    //showMessage(death_date);
  end;
  
	biography:='';
  isBio:=Pos('biografia/">Biografia</a>', all);
  if isBio>0 then begin
		all2:=DownloadURLWithReferer(bioUrl,refer);
    i:=Pos('<h2 class="timeline-section-title">Cenni',all2);
    delete(all2,1,i);
    i:=Pos('</p>',all2);
    all2:=copy(all2,1,i+5);
    //ShowMessage(all2);
		s:=ParseString(all2,'<p>(.*?)</p>',1);
		s:=RemoveTags(s);
		s:=DecodeHTML(s);
		s:=ClearExtraBlankCharacters(s);
		s:=convUTF(s);
		biography:=s;
	end;

	//Movies
  isMovie:=-1;
  i:=Pos('filmografia/">Filmografia</a>', all);
  if i>0 then isMovie:=1;
  url:=filmUrl;
	while isMovie>0 do begin
		all2:=DownloadURLWithReferer(url,refer2);
    i:=Pos('<h2 class="timeline-section-title">Filmografia',all2);
    j:=Pos('<footer>',all2);
    all2:=copy(all2,i,j-1);
    i:=Pos('<div class="film-list-item-cover">',all2);
    while i>0 do begin
			delete(all2,1,i+2);
			i:=Pos('<div class="vote-stars">',all2);
			s2:=copy(all2,1,i);
      s2:=RemoveEndLines(s2);
      i:=Pos('<a href="/film',s2);
      mov_code:='';
      if i>0 then begin
        isSerie:=0;
        mov_code:='film/'+ParseString(s2,'<h3 class="film-list-item-title">.*?<a href="/film/(.*?)/">.*?</a> *</h3>',1);
        mov_title:=ParseString(s2,'<h3 class="film-list-item-title">.*?<a href="/film/.*?/">(.*?)</a> *</h3>',1);
      end
      else begin
        isSerie:=1;
        mov_code:='serietv/'+ParseString(s2,'<h3 class="film-list-item-title">.*?<a href="/serietv/(.*?)/">.*?</a> *</h3>',1);
        mov_title:=ParseString(s2,'<h3 class="film-list-item-title">.*?<a href="/serietv/.*?/">(.*?)</a> *</h3>',1);
      end;
      if mov_code <> '' then begin
   			mov_title:=convUTF(mov_title);
  			mov_title:=DecodeHTML(mov_title);
        year:=ParseString(s2,'<div class="film-list-item-date-genre">(\d{4})',1);        
        //showMessage('Code:'+mov_code+' Title:'+mov_title+' Year:'+year);
        s3:=GetStr(s2,'<div class="film-list-item-role">','</div>');
        i:=Pos('Recitazione',s3);
        if i > 0 then begin;    
  	      	mode:=3;
  	      	character:=ParseString(s3 ,'Recitazione \((.*?)\)',1);
  	      	character:=convUTF(character);
  	      	character:=DecodeHTML(character);
            i:=Pos('(',character);
            if i>0 then character:=character+')';
            if (isSerie=1) then begin
              episodi:=ParseString(s3 ,'ndash; (\d* episodi)',1);
              anni:=ParseString(s3 ,'(\d{4} &ndash; \d{4})',1);
              if (anni='') then anni:=ParseString(s3 ,'(\d{4}) *&ndash',1);
              
              if (episodi<>'') then begin
                 character:=character+' ('+episodi;
                 if (anni<>'') then character:=character+' ('+anni+')';
                 character:=character+')';
              end;
            end;
            //ShowMessage('Ruolo:['+character+']');
  					SetMovieName(mov_title, character, mode , mov_code, year);
        end;
        i:=Pos('Regia',s3);
        if (i>0) then begin
        	mode:=1;
          //ShowMessage('Regia:');
  				SetMovieName(mov_title,'', mode , mov_code, year);
  			end;
        i:=Pos('Sceneggiatura',s3);
        j:=Pos('Soggetto',s3);
        if (i>0) or (j>0) then begin
        	mode:=2;
          //ShowMessage('Regia:');
  				SetMovieName(mov_title,'', mode , mov_code, year);
  			end;
        j:=Pos('Musiche',s3);
  			if (j>0) then begin
        	mode:=4;
          //ShowMessage('Writer:');
  				SetMovieName(mov_title, '', mode , mov_code, year);
  			end;
      end; 
  		i:=Pos('<div class="film-list-item-cover">',all2);
		end;
  
  	i:=Pos('null;">Mostra altro',all2);
    if i > 0 then begin
      isMovie:=isMovie+1;
      url:=filmUrl+format('?pagina=%d',[isMovie]);
    	refer2:=refer+format('?pagina=%d',[isMovie]);
    end
    else begin
      isMovie:=-1;
	  end;
  end;
end; //function
	
//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then begin
		result:='';
	end
	else begin	
		result:=format('http://www.movieplayer.it/%s/',[code]);
	end;
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then begin
		result:='';
	end
	else begin	
		result:=format('http://www.movieplayer.it/personaggi/%s/biografia',[code]);
	end;
end;

begin

prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';

end.