﻿const
	script_name='adorocinema';
	language='Brazilian Portuguese';
	version=25;
	author='Vlad';
	MinProgramBuild=8000;
	PCount = 12;
	//MaxPicturesCount = 3;
var
	title, MovieName, s, s2, s3, s4, year, director, name, character, BasicURL, country, description, salary, awards: String;
	episodes, movie_code, movie_site_url, title_code, imdb_code: string;
	titles: array of string;
	titles_count: integer;
	i, j: integer;
	director_code, code: string;
	directors, writers, actors, characters, genres, imdb_codes: array of string;
	duration: integer;
	rating, imdb_rating: double;
	front_cover_url: string;
	posters_exists, ask_amazon: boolean;
	original_title, mpaa, mpaa_rating: string;
	prefixes: array [1..PCount] of string;
	DownloadMovieBigCover, DownloadMovieFullCast: Boolean; 
	DownloadMovieBigDescription, DownloadMovieComments: Boolean; 
	DownloadMovieStudios, DownloadMovieAwards, DownloadMovieEarnings: Boolean; 
	DownloadMovieAdditionalInfo, DownloadMovieSeasonsList: Boolean; 
	MaxShotsCount, MaxPostersCount: integer;
	resolution, barcode, aspect_ratio, features, media_format, video_codec: string;
	FotoURL, MovieNameGlobal: String;
	
	LinkCodes, RequestParameters: TStringList;
	
const
	medium_photo_resizer='/r_120_160';
	small_photo_resizer='/r_60_80';
	front_cover_resizer='/r_160_214';

function GetStr(str: String; s1: String; s2: String): String;
var
  I: Integer;
  J: Integer;
begin
  // Вырезает кусок строки между s1 и s2
	Result := '';
	I := Pos(LowerCase(s1), LowerCase(str));
	if I > 0 then
	begin
		J := MyPos(LowerCase(s2), LowerCase(str), I + Length(s1));
		if J > 0 then
  		Result := Copy(str, I + Length(s1), J - I - Length(s1));
	end;
end;
	
function MovieSearch: integer;
var
	i, j, k, l: integer;
	temp, s2, title, year, description, original_title, small_cover, tv_series, entitytype: string;
begin
	titles_count := 0;
	i := Pos('{"entitytype":', all);
	while i > 0 do begin
		temp := GetStr(all, '{"entitytype":', '{"entitytype":');
		if (temp = '') then begin
			k := Pos('{"entitytype":', all);
			delete(all, 1, k);
			temp := all;
		end;
		entitytype := GetStr(temp, '"', '"');
		if (entitytype = 'series') then
			tv_series := 'series'
		else
			tv_series := '';
		title := GetStr(temp, '"title1":"', '"');
		original_title := GetStr(temp, '"title2":"', '"');
		if title = '' then begin
			title := original_title;
			original_title := '';
		end;
		title_code := GetStr(temp, '"id":', ',');
		title_code := ParseString(title_code, '(\d+)', 1);
		year := GetStr(temp, '"productionyear","value":"', '"');
		year := ParseString(year, '(\d+)', 1);
		small_cover := GetStr(temp, '"thumbnail":"', '"');
		description := GetStr(temp, '"director","value":"', '"');
		if description <> '' then
			description := 'Direção: ' + description;
		if (title<>'') and (title_code <> '') then begin
			SetSearchResult2(title, tv_series + title_code, year, original_title, description, small_cover);
			titles_count := titles_count + 1;
		end;
		delete(all, 1, i);
		i := Pos('{"entitytype":', all);
	end;
	result:=titles_count;
end;
	
function MovieSearchOld: integer;
var
	i, j, k, l: integer;
	temp, s2, title, year, description, original_title, small_cover, tv_series: string;
begin
	s:='';
	titles_count:=0;
	s := GetStr(all, 'Filmes</h2>', '</table>');
	if s = '' then
		s := GetStr(all, 'Filmes'#10'</h2>', '</table>');
	tv_series := GetStr(all, 'Série de TV'#10'</h2>', '</table>');
	if s = '' then begin
		s := tv_series;
		tv_series := '';
	end;
	if (s = '') then
	//movie not found
	else begin
		i:=pos('<tr>', s);
		while i>0 do begin
			temp:=GetStr(s, '<tr>', '</tr>');
			title := GetStr(temp, '<div>', '</a>');
			title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(title)));
			title_code := GetStr(temp, ' href=''/filmes/filme-', '/');
			if title_code = '' then begin
				title_code := GetStr(temp, ' href=''/series/serie-', '/');
				if title_code <> '' then
					title_code := 'series' + title_code;
			end;
			small_cover := GetStr(temp, 'src=''', '''');
			if (Pos('emptysearchposter', small_cover)>0) then
				small_cover := '';
			original_title := GetStr(temp, '</b>', '<br');
			original_title := DecodeHTML(GetStr(original_title, '(', ')'));
			s2 := GetStr(temp, '<span', '<div>');
			if s2 = '' then
				s2 := GetStr(temp, '<span', '</div>');
			year := GetStr(s2, '">', '<br');
			year := ParseString(year, '(\d+)', 1);
			j := Pos('<br />', s2);
			if j>0 then
				delete(s2, 1, j-1);
			s2 := ReplaceStr(s2, '<br />', #13#10, -1);
			description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(s2)));
			if (title<>'') and (title_code <> '') then begin
				SetSearchResult2(title, title_code, year, original_title, description, small_cover);
				titles_count := titles_count + 1;
			end;
			delete(s, 1, i);
			i:=pos('<tr>', s);
			if (i = 0) and (tv_series <> '') then begin
				s := tv_series;
				tv_series := '';
				i:=pos('<tr>', s);
			end;
		end;
	end;
	result:=titles_count;
end;

//get  movie name by barcode(UPC-12)
function GetMovieNameByUPC(barcode: string): string;
var
	url, all, s2, s3, res: string;
	i, j: integer;
begin
	res:='';
	url:=format('http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&SubscriptionId=0J0N83PT9M72BYH98YR2&Operation=ItemSearch&Keywords=%s&SearchIndex=Video&ResponseGroup=Request,Images,Tracks,ItemAttributes', [barcode]);	
	url:=ReplaceStr(url, ' ', '+', -1);
	all:=DownloadURL(url);
	//search image by title
	i:=pos('<Item>', all);
	while (i>0) and (res='') do begin
		j:=MyPos('</Item>', all, i+1);
		if j>0 then begin
			s2:=copy(all, i, j-i);
			s3:=ParseString(s2, '<Title>(.*?) \(.*\)</Title>', 1);
			if s3='' then
				s3:=ParseString(s2, '<Title>(.*?)</Title>', 1);
			if s3<>'' then
				res:=s3;
		end;
		i:=MyPos('<Item>', all, i+1);
	end;
	i:=pos('[', res);
	if i>0 then begin
		j:=MyPos(']', res, i+1);
		if j>0 then
			delete(res, i, j-i+1);
	end;
	result:=res;
end;

//Get search URL by movie name
function GetSearchURLbyName(MovieName: string; AYear: string; ABarcode: String): string;
var
	url: string;
begin
	MovieName := EncodeURL(MovieName, 'utf-8');
	MovieNameGlobal := MovieName;
	//url:=format('http://www.adorocinema.com/busca/?q=%s', [MovieName]);
	url := 'http://essearch.allocine.net/br/autocomplete?q=' + MovieName;
	url:=ReplaceStr(url, ' ', '+', -1);
	result:=url;
end;

//Download search results from URL
function DownloadSearchURL(url: string): integer;
begin
	//all:=DownloadURLWithReferer(url, 'http://www.adorocinema.com', False, RequestParameters);
	all := DownloadURLWithReferer(url, 'http://www.adorocinema.com', False, RequestParameters, 'utf-8');
	if all='-1' then
		result:=-1
	else
		result:=MovieSearch;
end;

function GetMovieURL(code: string; images_only: boolean): string;
begin
	if (Pos('series', code) > 0) then
		result := 'http://www.adorocinema.com/series/serie-'+copy(code, 7, length(code)-6)+'/'
	else
		result:='http://www.adorocinema.com/filmes/filme-'+code+'/';
end;


//save front cover to file
function SaveFrontCover(url, FileName: string): boolean;
var
	fs: TFileStream;
	s, referer: string;
	i: integer;
begin
	s:=DownloadURL(url);
	if (length(s)>0) and (s<>'-1') then begin
		try
			fs:=TFileStream.Create(FileName, fmCreate);
			fs.Write(s, Length(s));
			fs.Free;
			result:=true;
		except
			result:=false;
		end;
	end
	else
		result:=false;
end;

function MovePrefixLeft(name: string): string;
var
	i, j: integer;
begin
	// replace "The", "A", "An"... to the left
	for j:=1 to PCount do
	begin
		i:=pos(', '+Prefixes[j], name);
		if i>0 then
			if (i = length(name)-length(Prefixes[j])-1) or
			(length(name) >= i+2+length(Prefixes[j])) and (name[i+2+length(Prefixes[j])]=':') then
			begin
				if Prefixes[j][length(Prefixes[j])] = '''' then
					name := Prefixes[j] + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1)
				else
					name := Prefixes[j]+' ' + copy(name, 1, i-1) + copy(name, i+length(Prefixes[j])+2, length(name)-i-length(Prefixes[j])-2+1);
				break;
			end;
	end;
	Result := name;
end;

function ClearExtraQuotes(name: string): string;
begin
	// Clears extra quotes «"»
	if length(name)>0 then
		if (name[1]='"') and (name[length(name)]='"') then
			name := copy(name,2,length(name)-2);
	Result := name;
end;

procedure ExtractPeopleOld(text: String; mode: Integer; AcceptedRoles: TStringList);
var
	s, temp, name, character, code, photo, link_code: String;
	i, k: Integer;
begin
	i := Pos('<li', text);
	while i>0 do begin
		s := GetStr(text, '<li', '</li>');
		name := RemoveTags(GetStr(s, 'itemprop="name">', '</'));
		if name = '' then begin
			name := GetStr(s, '<p>', '</');
			if name <> '' then
				name := RemoveTags('<' + name);
		end;
		name := ClearExtraBlankCharacters(DecodeHTML(name));
		code := ParseString(s, ' href="/personalidades/personalidade-(\d+)/', 1);
		link_code := GetStr(s, 'class="acLnk ', '"');
		if (code <> '') and (link_code <> '') then
			LinkCodes.Add(link_code + '=' + code);
		photo := GetStr(s, 'src=''', '''');
		k := Pos(medium_photo_resizer, photo);
		if k>0 then
			delete(photo, k, length(medium_photo_resizer));
		if Pos('empty', photo)>0 then
			photo := '';
		character := '';
		if mode = 3 then begin
			character := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(GetStr(s, 'Personagem: ', '</p>'))));
		end;
		if (name <> '') then
			SetPersonName(name, character, mode, code, photo);
		delete(text, 1, i);
		i := Pos('<li', text);
	end;
	temp := GetStr(text, '<table class="table_02">', '</table>');
	if temp = '' then
		temp := GetStr(text, '<table class="table', '</table>');
	//alternative
	i := Pos('<tr', temp);
	while i>0 do begin
		s := GetStr(temp, '<tr', '</tr>');
		s := ReplaceStr(s, '<td>'#10'</td>', '', -1);
		character := GetStr(s, '<td>', '</td>');
		character := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(character)));
		delete(s, 1, Pos('</td>', s));
		name := GetStr(s, '<td>', '</td>');
		code := ParseString(name, ' href="/personalidades/personalidade-(\d+)', 1);
		link_code := GetStr(s, 'class="acLnk ', '"');
		if (link_code <> '') then begin
			if code = '' then
				code := LinkCodes.Values[link_code];
		end;
		name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(name)));
		photo := GetStr(s, 'src=''', '''');
		k := Pos(small_photo_resizer, photo);
		if k>0 then
			delete(photo, k, length(small_photo_resizer));
		if Pos('empty', photo)>0 then
			photo := '';
		if mode <> 3 then begin
			if (AcceptedRoles.IndexOf(character) < 0) then
				name := '';
			character := '';
		end;
		if (name <> '') then
			SetPersonName(name, character, mode, code, photo);
		delete(temp, 1, i);
		i := Pos('<tr', temp);
	end;
end;

procedure ExtractPeople(text: String; mode: Integer; AcceptedRoles: TStringList);
var
	s, temp, name, character, code, photo, link_code: String;
	i, j, k: Integer;
begin
	i := Pos(' col-xs-6">', text);
	while i>0 do begin
		j := MyPos('</div>', text, i + 1);
		j := MyPos('</div>', text, j + 1);
		s := copy(text, i, j - i);
		name := RemoveTags(GetStr(s, 'itemprop="name">', '</'));
		if name = '' then begin
			name := GetStr(s, '<p>', '</');
			if name <> '' then
				name := RemoveTags('<' + name);
		end;
		name := ClearExtraBlankCharacters(DecodeHTML(name));
		code := ParseString(s, ' href="/personalidades/personalidade-(\d+)/', 1);
		link_code := GetStr(s, 'class="acLnk ', '"');
		if (code <> '') and (link_code <> '') then
			LinkCodes.Add(link_code + '=' + code);
		photo := GetStr(s, 'src=''', '''');
		if photo = '' then
			photo := GetStr(s, 'data-src="', '"');
		k := Pos(medium_photo_resizer, photo);
		if k>0 then
			delete(photo, k, length(medium_photo_resizer));
		k := Pos(front_cover_resizer, photo);
		if k>0 then
			delete(photo, k, length(front_cover_resizer));
		k := Pos('/c_160_213', photo);
		if k > 0 then
			delete(photo, k, length('/c_160_213'));
		if Pos('empty', photo)>0 then
			photo := '';
		character := '';
		if mode = 3 then begin
			character := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(ParseString(s, 'Personagem : (.*?)$', 1))));
		end;
		if (name <> '') then
			SetPersonName(name, character, mode, code, photo);
		delete(text, 1, i);
		i := Pos(' col-xs-6">', text);
	end;
	temp := text;
	//alternative
	i := Pos('<div class="row md-table-row', temp);
	while i>0 do begin
		s := GetStr(temp, '<div class="row md-table-row', '</div>');
		character := GetStr(s, 'item">', '</');
		character := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(character)));
		name := GetStr(s, 'itemprop="name">', '</span>');
		if name = '' then begin
			name := GetStr(s, 'link"', '</span>');
			if name <> '' then
				name := RemoveTags('<' + name);
		end;
		code := ParseString(s, ' href="/personalidades/personalidade-(\d+)', 1);
		link_code := GetStr(s, 'class="acLnk ', '"');
		if (link_code <> '') then begin
			if code = '' then
				code := LinkCodes.Values[link_code];
		end;
		name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(name)));
		photo := '';
		if mode <> 3 then begin
			if (AcceptedRoles.IndexOf(character) < 0) then
				name := '';
			character := '';
		end;
		if (name <> '') then
			SetPersonName(name, character, mode, code, photo);
		delete(temp, 1, i);
		i := Pos('<div class="row md-table-row', temp);
	end;
end;

function GetInfo(url: string; images_only: boolean): string;
var 
	keyword, s, s2, s3, plot_outline, shot, shot_prefix, shot_ext, sh, sm, st, sa, sr, TmpAll, sc, season_code: string;
	i, j, k, frames_count, sb, se: integer;
	actors, IsTVSeries: boolean;
	name, character, code, temp, cast_url, cast_page, small_photo: String;
	AcceptedRoles: TStringList;
begin
	IsTVSeries := False;
	result:='';
	all:=DownloadURLWithReferer(url, 'http://www.adorocinema.com/busca/', False, RequestParameters);
	if all='-1' then
		result:='-1'
	else
		result:=all;
	
	if length(all) < 1000 then
		showMessage(all);
	LinkCodes := TStringList.Create;
	
	movie_code:=ParseString(url, 'http://www.adorocinema.com/filmes/filme-(\d+)/',1);
	if movie_code = '' then begin
		movie_code:=ParseString(url, 'http://www.adorocinema.com/series/serie-(\d+)/',1);
		if movie_code <> '' then begin
			movie_code := 'series' + movie_code;
			IsTVSeries := True;
		end;
	end;
		
	cast_url := '';
	if DownloadMovieFullCast and (Pos('/creditos/', all)>0) then begin
		cast_url := url + 'creditos/';
		AddRequestForHTMLPageContent(cast_url, True, url, '', RequestParameters);
	end;
	if IsTVSeries and DownloadMovieFullCast then begin
		s := GetStr(all, '<div class=''tabs_main''>', '</div>');
		season_code := ParseString(s, 'href="/series/serie-\d+/temporada-(\d+)', 1);
		if season_code <> '' then begin
			cast_url := url + 'temporada-' + season_code + '/elenco/';
			AddRequestForHTMLPageContent(cast_url, True, url, '', RequestParameters);
		end;
	end;
	
	FotoURL := '';
	if ((MaxShotsCount > 0) or (MaxPostersCount > 0)) and (Pos('/fotos/', all)>0) then begin
		FotoURL := url + 'fotos/';
		AddRequestForHTMLPageContent(FotoURL, True, url, '', RequestParameters);
	end;
	
	movie_site_url:=GetMovieSiteURL(movie_code);
	//movie title
	i := Pos('<title>', all);
	j := MyPos(' - ', all, i+1);
	title := copy(all, i+7, j-i-7);
	title := ClearExtraBlankCharacters(DecodeHTML(title));
	if title='' then exit;

	//original title
	original_title := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(GetStr(all, 'Título original', '</div>'))));
	if (original_title = '') then
		original_title := title;

	//genres
	temp := GetStr(all, 'Gêneros</span>', '</div>');
	i := Pos('</tr>', temp);
	if i > 0 then
		delete(temp, i, length(temp)-i+1);
	if temp = '' then
		temp := GetStr(all, 'Gênero</span>', '</tr>');
	temp := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(temp)));
	while (temp <> '') do begin
		i := Pos(',', temp);
		if i = 0 then
			i := Length(temp) + 1;
		s := copy(temp, 1, i-1);
		s := ClearExtraBlankCharacters(s);
		if s <> '' then
			SetGenre(s);
		delete(temp, 1, i);
	end;

	//duration
	duration:=0;
	temp := GetStr(all, '<span itemprop="duration"', '</span>');
	if temp <> '' then
		temp := ClearExtraBlankCharacters(RemoveTags('<' + temp))
	else begin
		temp := GetStr(all, 'Data de lançamento</span>', '</div>');
		temp := GetStr(temp, '(', ')');
	end;
	if IsTVSeries then begin
		temp := GetStr(all, 'Duração</span>', '</tr>');
		temp := ClearExtraBlankCharacters(RemoveTags(temp));
	end;
	sm := ParseString(temp, '(\d+)min', 1);
	if sm = '' then
		sm := ParseString(temp, '(\d+) min', 1);
	sh := ParseString(temp, '^(\d+)h', 1);
	i := 0;
	if (sm <> '') then begin
		try 
			Duration := StrToInt(sm);
			i := StrToInt(sh);
		except
		end;
		if i > 0 then
			Duration := Duration + i*60;
	end;

	//countries
	temp := GetStr(all, 'Nacionalidade</span>', '</div>');
	if temp = '' then
		temp := GetStr(all, 'Nacionalidade'#10'</span>', '</tr>');
	if IsTVSeries then begin
		temp := GetStr(all, 'País</span>', '</tr>');
	end;
	temp := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(temp)));
	while (temp <> '') do begin
		i := Pos(',', temp);
		if i = 0 then
			i := Length(temp) + 1;
		s := copy(temp, 1, i-1);
		s := ClearExtraBlankCharacters(s);
		if s <> '' then
			SetCountry(s);
		delete(temp, 1, i);
	end;

	//Year
	temp := GetStr(all, 'Ano de produção</span>', '</div>');
	if temp = '' then
		temp := GetStr(all, 'Ano de produção</div>', '</td>');
	temp := RemoveTags(temp);
	year := ParseString(temp, '(\d+)', 1);
	if IsTVSeries then begin
		temp := GetStr(all, '<title>', '</title>');
		year := ParseString(temp, '- Série (\d+)', 1);
	end;
	
	//synopsis
	temp := GetStr(all, 'itemprop="description">', '</p>');
	description := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(temp)));
	
	//front cover
	temp := GetStr(all, '<div class="poster">', '</div>');
	front_cover_url := GetStr(temp, ' src=''', '''');
	if IsTVSeries then
		front_cover_url := GetStr(all, '<meta property="og:image" content="', '"');
	if front_cover_url = '' then
		front_cover_url := GetStr(all, 'property="og:image" content="', '"');
	i := Pos(front_cover_resizer, front_cover_url);
	if i>0 then
		delete(front_cover_url, i, length(front_cover_resizer));
	if Pos('empty', front_cover_url) > 0 then
		front_cover_url := '';
		
	//Orçamento
	salary := '';
	if DownloadMovieAdditionalInfo then begin
		temp := GetStr(all, 'Orçamento</span>', '</div>');
		if temp = '' then
			temp := GetStr(all, 'Orçamento</div></th>', '</td>');
		temp := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(temp)));
		if (temp <> '-') and (temp <> '') then
			salary := 'Orçamento: ' + temp;
	end;
	
	//site visitors rating
	rating := 0;
	temp := GetStr(all, 'Leitores'#10'</a>', '</div>');
	if temp = '' then begin
		temp := GetStr(all, 'itemprop="ratingValue"', '>');
		temp := GetStr(temp, 'content="', '"');
		i := Pos('.', temp);
	end
	else begin
		temp := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(temp)));
		i := pos(',', temp);
	end;
	if i > 0 then
		temp[i]:=DecimalSeparator;
	try
		rating:=StrToFloat(temp);
	except
	end;
	
	//studios
	if DownloadMovieStudios then begin
		temp := GetStr(all, 'Distribuidor</span>', '</div>');
		if temp = '' then
			temp := GetStr(all, 'Distribuidor</div></th>', '</td>');
		temp := ClearExtraBlankCharacters(DecodeHTML(RemoveTags(temp)));
		while (temp <> '') do begin
			i := Pos(',', temp);
			if i = 0 then
				i := Length(temp) + 1;
			s := copy(temp, 1, i-1);
			s := ClearExtraBlankCharacters(s);
			if (s <> '') and (s <> '-') then
				SetStudio(s);
			delete(temp, 1, i);
		end;
	end;
	
	
	//cast and crew
	if cast_url <> '' then begin
		AcceptedRoles := TStringList.Create;
		cast_page := GetHTMLPageContentFromRequest(cast_url);
		//directors
		AcceptedRoles.Clear;
		i := Pos('Direção</h2>', cast_page);
		if IsTVSeries then begin
			i := Pos('Diretores'#10'<span', cast_page);
			if i > 0 then begin
				j := MyPos('<div class="sep_', cast_page, i+1);
				s := copy(cast_page, i, j-i);
				AcceptedRoles.Add('');
				AcceptedRoles.Add('Diretor');
				ExtractPeopleOld(s, 1, AcceptedRoles);
			end;
		end;
		if i>0 then begin
			j := MyPos(' class="section', cast_page, i+1);
			s := copy(cast_page, i, j-i);
			AcceptedRoles.Add('');
			AcceptedRoles.Add('Diretor');
			ExtractPeople(s, 1, AcceptedRoles);
		end;
		//actors
		i := Pos('Elenco</h2>', cast_page);
		if IsTVSeries then begin
			i := Pos('Atores e atrizes'#10'<span', cast_page);
			if i > 0 then begin
				j := MyPos('<div class="sep_', cast_page, i+1);
				s := copy(cast_page, i, j-i);
				AcceptedRoles.Clear;
				ExtractPeopleOld(s, 3, AcceptedRoles);
			end;
		end;
		AcceptedRoles.Clear;
		if i>0 then begin
			j := MyPos(' class="section', cast_page, i+1);
			s := copy(cast_page, i, j-i);
			ExtractPeople(s, 3, AcceptedRoles);
		end
		else begin
			i := Pos('Dubladores (vozes originais)', cast_page);
			if i>0 then begin
				j := MyPos(' class="section', cast_page, i+1);
				s := copy(cast_page, i, j-i);
				ExtractPeople(s, 3, AcceptedRoles);
			end;
		end;
		//screenplay
		AcceptedRoles.Clear;
		i := Pos('Roteiro</h2>', cast_page);
		if IsTVSeries then begin
			i := Pos('Roteiro'#10'<span', cast_page);
			if i > 0 then begin
				j := MyPos('<div class="sep_', cast_page, i+1);
				s := copy(cast_page, i, j-i);
				AcceptedRoles.Add('Roteirista');
				ExtractPeopleOld(s, 2, AcceptedRoles);
			end;
		end;
		if i>0 then begin
			j := MyPos(' class="section', cast_page, i+1);
			s := copy(cast_page, i, j-i);
			AcceptedRoles.Add('Roteirista');
			ExtractPeople(s, 2, AcceptedRoles);
		end;
		//composers
		AcceptedRoles.Clear;
		i := Pos('Trilha Sonora</h2>', cast_page);
		if IsTVSeries then begin
			i := Pos('Soundtrack'#10'<span', cast_page);
			if i > 0 then begin
				j := MyPos('<div class="sep_', cast_page, i+1);
				s := copy(cast_page, i, j-i);
				AcceptedRoles.Add('Compositor');
				ExtractPeopleOld(s, 4, AcceptedRoles);
			end;
		end;
		if i>0 then begin
			j := MyPos(' class="section', cast_page, i+1);
			s := copy(cast_page, i, j-i);
			AcceptedRoles.Add('Compositor');
			ExtractPeople(s, 4, AcceptedRoles);
		end;
		//producers
		AcceptedRoles.Clear;
		i := Pos('Produção</h2>', cast_page);
		if IsTVSeries then begin
			i := Pos('Produção'#10'<span', cast_page);
			if i > 0 then begin
				j := MyPos('<div class="sep_', cast_page, i+1);
				s := copy(cast_page, i, j-i);
				AcceptedRoles.Add('Produtor');
				ExtractPeopleOld(s, 5, AcceptedRoles);
			end;
		end;
		if i>0 then begin
			j := MyPos(' class="section', cast_page, i+1);
			s := copy(cast_page, i, j-i);
			AcceptedRoles.Add('Produtor');
			ExtractPeople(s, 5, AcceptedRoles);
		end;
		//cinematographer
		AcceptedRoles.Clear;
		i := Pos('Equipe técnica</h2>', cast_page);
		if IsTVSeries then begin
			i := Pos('Equipe técnica'#10'<span', cast_page);
			if i > 0 then begin
				j := MyPos('<div class="sep_', cast_page, i+1);
				s := copy(cast_page, i, j-i);
				AcceptedRoles.Add('Diretor de fotografia');
				ExtractPeopleOld(s, 6, AcceptedRoles);
			end;
		end;
		if i>0 then begin
			j := MyPos(' class="section', cast_page, i+1);
			s := copy(cast_page, i, j-i);
			AcceptedRoles.Add('Diretor de fotografia');
			ExtractPeople(s, 6, AcceptedRoles);
		end;
		AcceptedRoles.Free;
	end
	else begin
		//directors
		temp := GetStr(all, 'Direção:</span>', '</div>');
		i := Pos('itemprop="director"', temp);
		while i > 0 do begin
			s := GetStr(temp, 'itemprop="director"', '</span>');
			name := ClearExtraBlankCharacters(DecodeHTML(RemoveTags('<' + s)));
			code := ParseString(s, ' href="/personalidades/personalidade-(\d+)', 1);
			if name <> '' then
				SetPersonName(name, '', 1, code);
			delete(temp, 1, i);
			i := Pos('itemprop="director"', temp);
		end;
		//actors
		temp := GetStr(all, 'Elenco</span>', '</section>');
		AcceptedRoles.Clear;
		ExtractPeople(temp, 3, AcceptedRoles);		
	end;
	LinkCodes.Free;

end;

procedure ExtractImagesOld(text: String; mode, max_cnt: Integer);
var
	i, k, img_cnt: Integer;
	s, img_url: String;
const
	resizer = '/c_100_100';
begin
	img_cnt := 0;
	i := Pos('<li', text);
	while (i>0) and (img_cnt < max_cnt) do begin
		s := GetStr(text, '<li', '</li>');
		img_url := GetStr(s, 'data-attr=''{"src":"', '"');
		if img_url = '' then
			img_url := GetStr(s, ' src=''', '''');
		k := Pos(resizer, img_url);
		if k>0 then
			delete(img_url, k, length(resizer));
		if img_url <> '' then begin
			SetImageName('', img_url, '', mode);
			Inc(img_cnt);
		end;
		delete(text, 1, i);
		i := Pos('<li', text);
	end;
end;

procedure ExtractImages(text: String; mode, max_cnt: Integer);
var
	i, k, img_cnt: Integer;
	s, img_url: String;
const
	resizer = '/c_300_300';
begin
	img_cnt := 0;
	i := Pos('<a class="shot-item', text);
	while (i>0) and (img_cnt < max_cnt) do begin
		s := GetStr(text, '<a class="shot-item', '</a>');
		img_url := GetStr(s, 'data-src="', '"');
		if img_url = '' then
			img_url := GetStr(s, ' src=''', '''');
		k := Pos(resizer, img_url);
		if k>0 then
			delete(img_url, k, length(resizer));
		if img_url <> '' then begin
			SetImageName('', img_url, '', mode);
			Inc(img_cnt);
		end;
		delete(text, 1, i);
		i := Pos('<a class="shot-item', text);
	end;
end;

//returned images links
procedure GetImages;
var
	i, j, image_count, mode, poster_count: integer;
	s, s2, temp: string;
begin
	if front_cover_url <> '' then
		SetImageName('', front_cover_url, '', 1);
	if FotoURL <> '' then begin
		temp := GetHTMLPageContentFromRequest(FotoURL);
		if MaxPostersCount > 0 then begin
			s := GetStr(temp, 'Poster</h2>', #10'</div>');
			ExtractImages(s, 4, MaxPostersCount);
		end;
		if MaxShotsCount > 0 then begin
			s := GetStr(temp, 'Fotos</h2>', #10'</div>');
			if s = '' then begin
				s := GetStr(temp, 'fotos relacionadas com a série', '</ul>');
				ExtractImagesOld(s, 3, MaxShotsCount);
			end
			else
				ExtractImages(s, 3, MaxShotsCount);
		end;
	end;
end;

function ClearExtraBlankCharacters(text: string): string;
begin
	// Clear all extra blank characters
	while (length(text) > 0) and (ord(text[1]) in [1..20, 32]) do
		delete(text, 1, 1);
	while (length(text) > 0) and (ord(text[length(text)]) in [1..20, 32]) do
		delete(text, length(text), 1);
	Result := text;
end;

//get movie site url
function GetMovieSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else begin
		if (Pos('series', code) > 0) then
			result := 'http://www.adorocinema.com/series/serie-'+copy(code, 7, length(code)-6)+'/'
		else
			result:='http://www.adorocinema.com/filmes/filme-'+code+'/';
	end;
end;

//get person site url
function GetPersonSiteURL(code: string): string;
begin
	if code='' then
		result:=''
	else
		result:='http://www.adorocinema.com/personalidades/personalidade-'+code+'/';
end;


begin

prefixes[1]:='The';
prefixes[2]:='A';
prefixes[3]:='An';
prefixes[4]:='La';
prefixes[5]:='Les';
prefixes[6]:='Des';
prefixes[7]:='L''';
prefixes[8]:='Un';
prefixes[9]:='El';
prefixes[10]:='Il';
prefixes[11]:='Le';
prefixes[12]:='Uno';

  RequestParameters := TStringList.Create();
  RequestParameters.Add('Host=www.adorocinema.com');
  RequestParameters.Add('Accept=text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8');
  RequestParameters.Add('Accept-Language=en-US,en;q=0.5');
  RequestParameters.Add('Connection=close');  
  RequestParameters.Add('Cache-Control=no-cache');  
  RequestParameters.Add('User-Agent= Mozilla/5.0 (Windows NT 6.3; WOW64; rv:36.0) Gecko/20100101 Firefox/36.0');

end.